; #########################################################################
  .486
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

    .code
; #########################################################################

SwapString proc public uses ecx edx esi edi Source:PTR BYTE,Dest:PTR BYTE,ln:DWORD

    ; ---------------------------------------------------------
    ; Swaps ln bytes of memory from Source buffer and Dest buffer
    ;      
    ; USAGE:
    ; invoke SwapString,ADDR Source,ADDR Dest,4096
    ;
    ; NOTE: Dest buffer must be at least as large as the source
    ;       buffer otherwise a page fault will be generated.
    ; ---------------------------------------------------------

    align 4

    mov ecx, [ln]
    mov esi, [Source]
    shr ecx, 2  
    mov edi, [Dest]

    .if ecx == 0
      jmp @3
    .endif

    .repeat 
        mov eax, [esi]
        mov edx, [edi]
        mov [edi], eax
        mov [esi], edx   
        add edi, 4
        add esi, 4
    .untilcxz
@3:
    mov ecx, [ln]
    and ecx, 3
@@:
    .if ecx == 0
      jmp @F
    .endif

    mov dl, byte Ptr[esi]
    mov al, byte Ptr[edi]
    mov byte Ptr[edi], dl
    mov byte Ptr[esi], al
    add edi, 1
    add esi, 1
    sub ecx, 1
    jmp @b
@@:
    ret

SwapString endp

; #########################################################################

end
