.586
.model flat, stdcall
option casemap :none


QSrtCore1   PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
SwapString  PROTO :DWORD,:DWORD,:DWORD

.code

align 8

;****************************************************************************************
TabSort proc uses ebx ecx edx edi esi , 
           pTable:dword,
           SortPos:dword,                   ; 1-based
           SortLen:dword,           
           LenRow:dword,
           Rows:dword
;****************************************************************************************
LOCAL IDIFF         :DWORD
LOCAL pLow          :DWORD
LOCAL pHigh         :DWORD
LOCAL pCMP1         :DWORD
LOCAL pCMP2         :DWORD
LOCAL pCMP3         :DWORD
LOCAL pMid          :DWORD
LOCAL pNewPos       :DWORD
LOCAL NewPos        :DWORD
LOCAL iHighNew      :DWORD
LOCAL iLowNew       :DWORD
LOCAL iLow          :DWORD
LOCAL iHigh         :DWORD

;****************************************************************************************
; Check Parameters
;****************************************************************************************

    mov eax, SortLen
    .if eax == 0 || eax > LenRow
       mov eax, 23
       ret
    .endif
    mov eax, SortPos
    .if eax == 0 || eax > LenRow
       mov eax, 25
       ret
    .endif
     add eax, SortLen
     dec eax
    .if eax > LenRow
       mov eax, 26
       ret
    .endif

    sub SortPos, 1            ; 0-based !

;****************************************************************************************
; Iterative Call 
;****************************************************************************************
    mov eax, dword ptr[-1]
    push eax
    push eax                       ; STOP condition
    
    push Rows
    mov eax, 1
    push eax

;****************************************************************************************
; QuickSort-Routine
;****************************************************************************************
align 4

Start:

    pop iLow
    pop iHigh
          
    mov eax, iLow
    .if eax == dword ptr[-1]
        xor eax, eax
        ret
;****************************************************************************************
;                              QuickSort-END
;****************************************************************************************
    .endif

align 4
@@:

    mov ecx,    iHigh
    .if ecx <= iLow
        jmp     Start
    .endif

    sub ecx,    iLow    
    add ecx,    1
    mov IDIFF,  ecx                ; count of elements
    
    mov eax,    iLow    
    sub eax,    1
    mul LenRow
    add eax,    pTable
    mov pLow, eax   

    mov eax,    iHigh
    sub eax,    1
    mul LenRow
    add eax,    pTable
    mov pHigh,  eax   


;#############################################################################
; Get mid element as new pivot element 
;#############################################################################
    mov eax,    pLow
    mov ecx,    pHigh
    mov pCMP1,  eax
    mov pCMP3,  ecx
      
    mov eax,    iLow
    add eax,    iHigh
    shr eax,    1
    
    sub eax,    1
    mul LenRow
    add eax,    pTable

    mov ecx,    SortPos
    mov pMid,   eax

    add pCMP1,  ecx
    add eax,    ecx

    add pCMP3,  ecx
    mov pCMP2,  eax
    
    invoke SwapString , pMid, pHigh, LenRow     ; --> CMP2

;#############################################################################

      mov ecx, IDIFF
      mov edx, pHigh
      mov eax, SortPos
      sub ecx, 1
      add edx, eax

;###################################################################################
; pivot is set to correct position,  using QSrtCore1 (Byte-wise)
;###################################################################################
      add eax, 1
      invoke QSrtCore1, pLow, edx, LenRow, ecx, eax, SortLen               ; 1-based

      mov NewPos,  eax             ; eax is correct position(relative) of [EDX]
      sub eax,      1
      mul LenRow
      add eax,      pLow
      mov pNewPos, eax      
      invoke SwapString , pNewPos, pHigh, LenRow          
      mov eax, NewPos

      .if eax > 2
         .if eax < IDIFF
            add eax,        iLow
            sub eax,        2
            mov iHighNew,   eax
            add eax,        2
            mov iLowNew,  eax

            neg eax
            mov ecx,        iHighNew
            add eax,        iHigh
            sub ecx,        iLow

            .if eax < ecx         ; comparing size of lower part against size upper part
                                  ; processing smaller array first
                push  iHighNew
                push  iLow
  
                push  iHigh
                push  iLowNew
                jmp   Start
            .else
                push  iHigh
                push  iLowNew
  
                push  iHighNew
                push  iLow
                jmp   Start
            .endif

         .else
                                
            sub  iHigh, 1
            push iHigh
            push iLow
            jmp  Start
         
         .endif
      .else
                                   ; if position 1 or 2, process only upper part
            add eax,    iLow
            mov iLow, eax
            push        iHigh
            push        iLow 
            jmp         Start

      .endif

      jmp Start


TabSort endp


END

