.586
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\msvcrt.lib

    include \masm32\macros\macros.asm

TabSort   PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
InspectTallying PROTO :DWORD,:DWORD,:DWORD
.data
    pF          dd ?
    lenF        dd ?
    Recs        dd ?
    lenRec      dd ?
    SortPos     dd 6                 ; city
    SortLen     dd 50                ; length of item

    CR          db 13, 10, 0, 0

comment *
    The file "ZipCodes.txt" contains 17689 records of all german ZIP-codes with corresponding 
    cities.
    Fixed length with rec delimiter x"0d0a"
    Record structure :  ZIP 5 char, city 50 char, 0d0a
    ----------------------------------------------------------------------------------- *      
    inFile      db "ZipCodes.txt", 0, 0, 0, 0
    outFile     db "ZipCodes.txt.Srt", 0
.code


start:
    cls
    
    print chr$("Table Sort example", 13, 10)

    invoke read_disk_file, ADDR inFile, ADDR pF, ADDR lenF
    .if eax == 0
       print chr$("Load Error Input", 13, 10)
       jmp @F
    .endif   

    invoke InspectTallying, pF, ADDR CR, lenF            ; tallying occurrence of x"0d"
    mov Recs, eax
    invoke InString, 1, pF, ADDR CR                      ; get length of record   
    mov lenRec, eax
    add lenRec, 1

    invoke TabSort, pF, SortPos, SortLen, lenRec, Recs   ; sort table
    .if eax != 0
       print ustr$(eax)
       print chr$(" = TabSort parameter error ", 13, 10) 
       jmp @F
    .endif   
    
    invoke write_disk_file, ADDR outFile, pF, lenF
    print ustr$(Recs)
    print chr$(" records sorted and written", 13, 10)
    

@@:
    mov   eax, input(13,10,"Press enter to exit...")

exit

END start

